unit A89_p_u;   {Programmer for AT89C2051 using the printer interface LPT1 or LPT2}
                {c/o Jrgen Heidbreder 15.3.2000; 29.03.2000}
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    read_mem: TButton;
    Read_sign: TButton;
    Program_Mem: TButton;
    Compare_mem: TButton;
    Set_LB1: TButton;
    Set_lb2: TButton;
    Erase_mem: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    HelpIndex1: TMenuItem;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure readfile;                           {aus readby}
    procedure read_memClick(Sender: TObject);
    procedure Read_signClick(Sender: TObject);
    procedure Program_MemClick(Sender: TObject);
    procedure Compare_memClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Set_LB1Click(Sender: TObject);
    procedure Set_lb2Click(Sender: TObject);
    procedure Erase_memClick(Sender: TObject);
    Procedure Put_Data2Screen;
    procedure LesenClick(Sender: TObject);
private
    { Private declarations }
  public
    { Public declarations }
  end;

const max_size = 4095;              {max size of code is 1,2,4k}

type arr = array[0..max_size] of byte;

var
  Form1: TForm1;
  bytes : arr;
  max_used : word;

const Pulse2Xtal = 128; Write_Code = 44; Read_Code = 36; Write_Lock1 = 60;
      Write_Lock2 = 56; Chip_Erase = 48; Read_Sig  = 32; Vcc_on = 8; busyflag =128;
      Reset2_0 = 0; Reset2_5 = 1; Reset2_12 = 4; Init = 0; Prog_Pulse = 32;

implementation

{$R *.DFM}

uses i2c_bas;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  form1.close;
end;

Procedure nullsetzen(var a : array of byte); {resets array to 255}
var in1 : smallint;
begin
  for in1 := 0 to high(a) do a[in1] := 255;
end;

procedure tform1.readfile;    {aus readby}
var
  FromF: file;
  NumRead, NumWritten: Word;
  Buf: array[1..16] of byte;
  i, zaehler : word;
begin
  nullsetzen(bytes);
  AssignFile(FromF, opendialog1.fileName);
  Reset(FromF,1);		{ Record size = 1 }
  zaehler := 0;
  repeat
    BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
  for i := 1 to numread do
  begin
   bytes[zaehler] := buf[i];
 {  memo1.lines.add(inttostr(bytes[zaehler])); }
   inc(Zaehler);
  end;
  until (NumRead <> sizeof(buf)) OR (zaehler > max_size);
  CloseFile(FromF);
  memo1.lines.add(inttostr(zaehler)+' Bytes gelesen');
  Put_Data2Screen;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  opendialog1.title := 'Open Binary File';
  opendialog1.filterindex := 1;
  opendialog1.fileName := '*.BIN';
  opendialog1.defaultext := 'BIN';
  if opendialog1.execute then readfile;
  program_mem.enabled := true;
  compare_mem.enabled := true;
end;

Function Check_LPT(var Adress: word): boolean;
var ulp : word;
begin
  check_LPT := false;
  port[Adress] := 1;
  delay(100);
  ulp := port[Adress+1] AND SDA_RX;
  if ulp <> 0 then exit;
  port[Adress] := 0;
  delay(100);
  ulp := port[Adress+1] AND SDA_RX;
  if ulp = SDA_Rx then check_LPT := true;
end;

Procedure Find_LPT;
type LPTS = array[1..2] of word;
var lpt : LPTS;
    il, ifound : byte;
begin
  LPT[1] := $378; LPT[2] := $278; LPT_Adr := 0; ifound := 0;
  for il := 1 to 2 do
  begin
     if Check_LPT(LPT[il]) then
     begin
       LPT_Adr := LPT[il];
       ifound := il;
       break;
     end;
  end;
  if LPT_Adr = 0 then showmessage('No LPT port found. Please check connection')
  else form1.caption := 'Programmer Interface detected at LPT'+inttostr(ifound);
end;

Procedure Power_up;
begin
  port[LPT_Adr + 2] := Init + Vcc_on + Reset2_5 ;{5V fr Prozessor}
  Delay(500);
  port[LPT_Adr + 2] := port[LPT_Adr + 2] - Reset2_5;
  Delay(1);
  port[LPT_Adr + 2] := port[LPT_Adr + 2] OR Reset2_5;  {Reset nun high}
  port[LPT_Adr]     := port[LPT_Adr] OR Prog_Pulse;    {== P3.2 high}
  ausgeben(255);
end;

Procedure Power_down;
var tmp :byte;
begin
  port[LPT_Adr]     := port[LPT_Adr] AND (255 - Pulse2Xtal); {set Xtal to low}
  tmp := port[LPT_Adr + 2];
  tmp := tmp AND (255 - Reset2_12 - Reset2_5);  {12V und 5V AUS}
  port[LPT_Adr + 2] := tmp;                     {set Reset to low}
  delay(100);
  ausgeben(0);
  port[LPT_Adr]     := port[LPT_Adr] AND 3; {all ports low}
  port[LPT_Adr + 2] := port[LPT_Adr + 2] AND (255 - Vcc_on); {turn Vcc off}
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  SCL := 2; SDA := 1; SDA_RX := 32; 
  find_LPT;
  port[LPT_Adr + 2] := Init;  {alle Spannungen aus}
  port[LPT_Adr]     := 0;
  I2C_init;
  ausgeben(0);          {changed from 255 to 0}
  nullsetzen(bytes);
end;

Procedure Busy(var waits : byte);
var u,v : byte;
    ready : boolean;
begin
  ready := false;
  v := 255;
  REPEAT
    u := port[LPT_ADR + 1];
    IF u AND Busyflag = busyflag then ready := true;
    dec(v);
    delay(1);
  until ready OR (v < 1);
  waits := 255 - v;
end;
  
Procedure tform1.Put_Data2Screen;
var t1, t2 : string;
    i : word;
begin
  t1 := '0000: '; t2 := '';
  FOR i := 0 to max_used do
  BEGIN
    t1 := t1 + inttohex(bytes[i],2) + ' ';
    if bytes[i] = 0 then t2 := t2 + ' '
    else t2 := t2 + chr(bytes[i]) + ' ';
    if ((i+1) MOD 8) = 0 then
    begin
      memo1.lines.add(t1 + ' ' + t2);
      t1 := inttohex(i+1,4) + ': ';
      t2 := '';
    end;
  end;
end;

procedure TForm1.read_memClick(Sender: TObject);
var i : word; ack : boolean;
begin
  Power_up;
  nullsetzen(bytes);
  label1.caption := '';
  port[LPT_Adr] := port[LPT_Adr] OR (Read_Code + 3); {set pins}
  I2C_Start;
  I2C_Aus(64,ack);     {Adresse}
  delay(1);
  I2C_Aus(255,ack);    {8 bit I/O frs Lesen vorbereiten}
  delay(1);
  I2C_Stop;
  delay(1);
  I2C_Start;           {Neustart}
  delay(1);
  I2C_Aus(65,ack);     {Adresse fr Lesen}
  if NOT Ack then Label1.caption := 'Rd_Mem: NO Ack received';
  for i:= 0 to max_used do
  begin
    port[LPT_Adr] := port[LPT_Adr] + Pulse2Xtal;
    delay(1);
    port[LPT_Adr] := port[LPT_Adr] - Pulse2Xtal;
    {delay(1);}
    bytes[i] := i2C_Ein;
    if i = max_used then No_Ack else Send_Ack;
  end;
  I2C_Stop;
  Power_down;
  Put_Data2Screen;
end;

procedure TForm1.Read_signClick(Sender: TObject);
type small_array = array[0..2] of byte;
var i,j : word; ack : boolean;
    ref, read : small_array;
begin
  ref[0] := $1E; ref[1] := $01;
  read[0] := 0; read[1] := 0;
  Power_up;
  label1.caption := '';
  port[LPT_Adr] := port[LPT_Adr] OR (Read_Sig + 3); {set pins}
  I2C_Start;
  I2C_Aus(64,ack);     {Adresse}
  I2C_Aus(255,ack);    {8 bit I/O frs Lesen vorbereiten}
  I2C_Stop;
  I2C_Start;           {Neustart}
  I2C_Aus(65,ack);     {Adresse fr Lesen}
  if NOT Ack then Label1.caption := 'Rd_Sign: NO Ack received';
  for i:= 0 to 2 do
  begin
    port[LPT_Adr] := port[LPT_Adr] + Pulse2Xtal;
    delay(1);
    port[LPT_Adr] := port[LPT_Adr] - Pulse2Xtal;
    delay(1);
    read[i] := i2C_Ein;
    if i = 2 then No_Ack else Send_Ack;
 end;
  I2C_Stop;
  Power_down;
  if ref[0] = read[0] then memo1.lines.add('Manufacturer: ATMEL')
  else memo1.lines.add('Unknown Manufacturer. Code read is: '+ inttohex(read[0],2));

  if ref[1] = ref[1] and $01 then
  begin
    j := (read[1] AND $F0 ) DIV 16;
    case J of
    1:   begin
           memo1.lines.add('Part ID: AT 89C1051');
           max_used := 1023;
         end;
    2:   begin
           memo1.lines.add('Part ID: AT 89C2051');
           max_used := 2047;
         end;
    4:   begin
           memo1.lines.add('Part ID: AT 89C4051');
           max_used := 4095;
         end;
  else memo1.lines.add('Unknown Part ID. Code read is: '+ inttohex(read[1],2));
    memo1.lines.add('Third Code read is: '+ inttohex(read[2],2));
  end;
end;
end;

procedure TForm1.Program_MemClick(Sender: TObject);
var i : word; ack : boolean;
begin
  Power_up;
  port[LPT_Adr] := port[LPT_Adr] OR (Write_Code + 3);       {set pins}
  port[LPT_Adr + 2] := port[LPT_Adr + 2] OR Reset2_12; {raise Reset to 12V}
  label1.caption := '';
  I2C_Start;
  I2C_Aus(64,ack);     {Adresse}
  if NOT Ack then Label1.caption := 'Pr_Mem1: NO Ack received';
  for i:= 0 to max_used do
  begin
   {  port[LPT_Adr] := port[LPT_Adr] + Pulse2Xtal;
    port[LPT_Adr] := port[LPT_Adr] - Pulse2Xtal;}
   if bytes[i] <> $FF then    {skip programming when $FF}
    begin
      I2C_Aus(bytes[i],Ack);
      if NOT Ack then Label1.caption := 'Pr_Mem2: NO Ack received';
      port[LPT_Adr] := port[LPT_Adr] AND (255 - Prog_Pulse);
      port[LPT_Adr] := port[LPT_Adr] + Prog_Pulse;
      delay(2);
     {  Busy;}                      {<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<}
    end;
    port[LPT_Adr] := port[LPT_Adr] + Pulse2Xtal;
    port[LPT_Adr] := port[LPT_Adr] - Pulse2Xtal;
  end;
  I2C_Stop;
  port[LPT_Adr + 2] := port[LPT_Adr + 2] AND (255 - Reset2_12);
  Power_down;
end;

procedure TForm1.Compare_memClick(Sender: TObject);
var i,j : word; ack,all_ok : boolean;
begin
  all_ok := true;
  Power_up;
  port[LPT_Adr] := port[LPT_Adr] OR (Read_Code + 3); {set pins}
  I2C_Start;
  I2C_Aus(64,ack);     {Adresse}
  I2C_Aus(255,ack);    {8 bit I/O frs Lesen vorbereiten}
  I2C_Start;           {Neustart}
  I2C_Aus(65,ack);     {Adresse fr Lesen}
  for i:= 0 to max_used do
  begin
    port[LPT_Adr] := port[LPT_Adr] + Pulse2Xtal;
    port[LPT_Adr] := port[LPT_Adr] - Pulse2Xtal;
    j := i2C_Ein;
    Send_Ack;
    if bytes[i] <> j then
    begin
      memo1.lines.add('ERROR COMPARE: Shall: '+ inttohex(bytes[i],2)
               +' Is: '+ inttohex(j,2)+ ' at Pos.: '+ inttohex(i,2));
      all_ok := false;
    end;
  end;
  I2C_Stop;
  Power_down;
  if all_ok then memo1.lines.add('COMPARE: all bytes OK');
end;

procedure TForm1.Button1Click(Sender: TObject);
var sp : byte;
begin
{  sp := strtoint(edit1.text);
  ausgeben(sp);    }
end;

procedure TForm1.Set_LB1Click(Sender: TObject);    
var i : word; ack : boolean;
begin
  Power_up;
  port[LPT_Adr] := port[LPT_Adr] OR (Write_Lock1 + 3);       {set pins}
  port[LPT_Adr + 2] := port[LPT_Adr + 2] OR Reset2_12; {raise Reset to 12V}
  port[LPT_Adr] := port[LPT_Adr] AND (255 - Prog_Pulse);
  port[LPT_Adr] := port[LPT_Adr] + Prog_Pulse;
      delay(2);
     {  Busy;}                       {<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<}
  port[LPT_Adr + 2] := port[LPT_Adr + 2] AND (255 - Reset2_12);
  Power_down;
end;

procedure TForm1.Set_lb2Click(Sender: TObject);  
var i : word; ack : boolean;
begin
  Power_up;
  port[LPT_Adr] := port[LPT_Adr] OR (Write_Lock2 + 3);       {set pins}
  port[LPT_Adr + 2] := port[LPT_Adr + 2] OR Reset2_12; {raise Reset to 12V}
  port[LPT_Adr] := port[LPT_Adr] AND (255 - Prog_Pulse);
  port[LPT_Adr] := port[LPT_Adr] + Prog_Pulse;
      delay(2);
     {  Busy;}
  port[LPT_Adr + 2] := port[LPT_Adr + 2] AND (255 - Reset2_12);
  Power_down;
end;

procedure TForm1.Erase_memClick(Sender: TObject);
var i : word; ack : boolean;
begin
  Power_up;
  port[LPT_Adr] := port[LPT_Adr] OR (Chip_Erase + 3);       {set pins}
  port[LPT_Adr + 2] := port[LPT_Adr + 2] OR Reset2_12; {raise Reset to 12V}
  port[LPT_Adr] := port[LPT_Adr] AND (255 - Prog_Pulse);
  delay(10);
  port[LPT_Adr] := port[LPT_Adr] + Prog_Pulse;
  port[LPT_Adr + 2] := port[LPT_Adr + 2] AND (255 - Reset2_12);
  Power_down;
end;

procedure TForm1.LesenClick(Sender: TObject);
var iw : word; ack : boolean;
begin
  ausgeben(255);     {nur auskommentieren fr Tests}
  I2C_Start;           {Neustart}
  I2C_Aus(65,ack);     {Adresse fr Lesen}
  if Ack then Label1.caption := 'lesen: Ack received' else Label1.caption := 'lesen: NO Ack received';
  iw := i2C_Ein;
  No_Ack;
  I2C_Stop;
{label2.caption := inttostr(iw);  }
end;

end.
